<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------


namespace app\adminapi\controller\master_worker;


use app\adminapi\controller\BaseAdminController;
use app\adminapi\lists\master_worker\MasterWorkerAgreeLists;
use app\adminapi\logic\master_worker\MasterWorkerAgreeLogic;
use app\adminapi\validate\master_worker\MasterWorkerAgreeValidate;
use app\common\logic\MasterWorkerExamineLogic;


/**
 * MasterWorkerAgree控制器
 * Class MasterWorkerAgreeController
 * @package app\adminapi\controller\master_worker
 */
class MasterWorkerAgreeController extends BaseAdminController
{


    /**
     * @notes 获取列表
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function lists()
    {
        return $this->dataLists(new MasterWorkerAgreeLists());
    }


    /**
     * @notes 添加
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function add()
    {
        $params = (new MasterWorkerAgreeValidate())->post()->goCheck('add');
        $result = MasterWorkerAgreeLogic::add($params);
        if (true === $result) {
            MasterWorkerExamineLogic::updateEngineerInformation($params['worker_id']);
            return $this->success('添加成功', [], 1, 1);
        }
        return $this->fail(MasterWorkerAgreeLogic::getError());
    }


    /**
     * @notes 编辑
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function edit()
    {
        $params = (new MasterWorkerAgreeValidate())->post()->goCheck('edit');
        $result = MasterWorkerAgreeLogic::edit($params);
        if (true === $result) {
            $info = MasterWorkerAgreeLogic::detail(['id'=>$params['id']]);
            MasterWorkerExamineLogic::updateEngineerInformation($info['worker_id']);
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->fail(MasterWorkerAgreeLogic::getError());
    }


    /**
     * @notes 删除
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function delete()
    {
        $params = (new MasterWorkerAgreeValidate())->post()->goCheck('delete');
        try {
            $worker_ids = MasterWorkerAgreeLogic::getWorkerIds($params);
            MasterWorkerAgreeLogic::delete($params);
            foreach ($worker_ids as $worker_id) {
                MasterWorkerExamineLogic::updateEngineerInformation($worker_id);
            }
            return $this->success('删除成功', [], 1, 1);
        } catch (\Exception $e) {
            return $this->fail('删除失败-'.$e->getMessage());
        }
    }


    /**
     * @notes 获取详情
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function detail()
    {
        $params = (new MasterWorkerAgreeValidate())->goCheck('detail');
        $result = MasterWorkerAgreeLogic::detail($params);
        return $this->data($result);
    }


}